AddCSLuaFile( "cl_init.lua" )
AddCSLuaFile( "shared.lua" )
include( "shared.lua" )

function ENT:Initialize()
	self:PhysicsInit( SOLID_VPHYSICS )
	self:SetMoveType( MOVETYPE_VPHYSICS )
	self:SetSolid( SOLID_VPHYSICS )
	
	local phys = self:GetPhysicsObject()
	if ( phys:IsValid() ) then
		phys:Wake()
		phys:SetBuoyancyRatio( 1 )
		self.BuoyancyRatio = 1
	end
	
	self.MinSpeed = self.MinSpeed or 100
	self.Damage = self.Damage or 100
	self.Radius = self.Radius or 100
	if ( self.OnlyWater == nil ) then self.OnlyWater = true end
end

function ENT:SetMinSpeed( speed ) self.MinSpeed = speed or self.MinSpeed end
function ENT:SetDamage( damage ) self.Damage = damage or self.Damage end
function ENT:SetRadius( radius ) self.Radius = radius or self.Radius end
function ENT:SetOnlyUW( only ) self.OnlyWater = only end

function ENT:CheckWater()
	if ( !self.OnlyWater ) then return true end
	if ( self:WaterLevel() > 0 ) then return true end
	
	local pos = self:GetPos()
	local trace = util.TraceLine( { start = pos, endpos = pos - Vector( 0, 0, self:BoundingRadius() ), filter = self, mask = MASK_WATER } )
	return trace.Hit
end

function ENT:PhysicsCollide( data, phys )
	if ( self.MinSpeed >= 0 && data.Speed >= self.MinSpeed ) then
		self:Explode()
	end
end
function ENT:OnTakeDamage( info )
	local hp = self:Health()
	if ( hp > 0 ) then
		hp = hp - info:GetDamage()
		self:SetHealth( hp )
		if ( hp <= 0 ) then self:Explode() end
	end
	self:TakePhysicsDamage( info )
end

function ENT:Explode()
	if ( !self:CheckWater() ) then return end
	if ( self.Exploded ) then return else self.Exploded = true end // Run once.
	
	// Boom.
	local exp = ents.Create( "env_explosion" )
		exp:SetPos( self:GetPos() )
		exp:SetKeyValue( "iMagnitude", self.Damage or 0 )
		if ( self.Radius >= 0 ) then
			exp:SetKeyValue( "iRadiusOverride", self.Radius or 0 )
		end
		if ( self.Owner ) then exp:SetOwner( self.Owner ) end
	exp:Spawn()
	exp:Fire( "Explode", "", 0 )
	
	// No more us.
	timer.Simple( 0, self.Remove, self )
end

if ( SERVER ) then
	local function Set( phys, ratio )
		if ( !phys:IsValid() ) then return end
		phys:SetBuoyancyRatio( ratio )
	end
	local function OnDrop( ply, ent )
		if ( ent.BuoyancyRatio ) then
			local phys = ent:GetPhysicsObject()
			if ( phys:IsValid() ) then
				timer.Simple( 0, Set, phys, ent.BuoyancyRatio )
			end
		end
	end
	hook.Add( "PhysgunDrop", "rt_buoyancy", OnDrop )
	hook.Add( "GravGunOnDropped", "rt_buoyancy", OnDrop )
end