
TOOL.Category		= "Construction"
TOOL.Name			= "#Naval Mines"
TOOL.Command		= nil
TOOL.ConfigName		= ""

if ( CLIENT ) then
	language.Add( "Tool_rt_navalmines_name", "Naval Mines" )
	language.Add( "Tool_rt_navalmines_desc", "Creates floating bombs." )
	language.Add( "Tool_rt_navalmines_0", "Left click to make a mine on a rope, right click to just create a mine" )
	language.Add( "Undone_NavalMine", "Undone Naval Mine" )
	language.Add( "SBoxLimit_navalmines", "You've hit the Naval Mine limit!" )
	language.Add( "Cleanup_navalmines", "Naval Mines" )
end
if ( SERVER ) then
	CreateConVar( "sbox_maxnavalmines", 10 )
end

TOOL.ClientConVar[ "model" ] = "models/combine_helicopter/helicopter_bomb01.mdl"
TOOL.ClientConVar[ "ropelength" ] = "128"
TOOL.ClientConVar[ "speed" ] = "100"
TOOL.ClientConVar[ "damage" ] = "100"
TOOL.ClientConVar[ "radius" ] = "-1"
TOOL.ClientConVar[ "health" ] = "-1"
TOOL.ClientConVar[ "onlywater" ] = "1"

cleanup.Register( "navalmines" )

function TOOL:LeftClick( trace, norope )
	if ( CLIENT ) then return true end
	
	local vals = self:GetValues( { model = "string", speed = "number", damage = "number", radius = "number", health = "number", onlywater = "number" } )
	if ( vals == false ) then return end
	
	// Update existing mine.
	if ( ValidEntity( trace.Entity ) && trace.Entity:GetClass() == "rt_navalmine" ) then
		local mine = trace.Entity
		mine:SetModel( vals.model )
		mine:SetMinSpeed( vals.speed )
		mine:SetDamage( vals.damage )
		mine:SetRadius( vals.radius )
		mine:SetOnlyUW( vals.onlywater == 1 )
		mine:SetHealth( vals.health )
		
		return true
	end
	
	local ply = self:GetOwner()
	if ( !ply:CheckLimit( "navalmines" ) ) then return false end
	
	undo.Create( "NavalMine" )
	
	local mine = ents.Create( "rt_navalmine" )
		mine:SetModel( vals.model )
		mine:SetMinSpeed( vals.speed )
		mine:SetDamage( vals.damage )
		mine:SetRadius( vals.radius )
		mine:SetOnlyUW( vals.onlywater == 1 )
		mine:SetHealth( vals.health )
		mine.Owner = ply
	mine:Spawn()
	mine:SetPos( trace.HitPos + ( trace.HitNormal * mine:BoundingRadius() ) )
	undo.AddEntity( mine )
	
	if ( !norope ) then
		local pos = list.Get( "NavalMineModels" )[ vals.model ] or Vector( 0, 0, -4 )
		local length = ( trace.HitPos - mine:LocalToWorld( Vector( pos ) ) ):Length()
		local rope = constraint.Rope(
			trace.Entity,
			mine,
			trace.PhysicsBone,
			0,
			trace.Entity:WorldToLocal( trace.HitPos ),
			pos,
			length,
			vals.ropelength - length,
			0,
			2,
			"cable/rope",
			false
		)
		undo.AddEntity( rope )
	end
		
	undo.SetPlayer( ply )
 	undo.Finish()
	
	ply:AddCount( "navalmines", mine )
	ply:AddCleanup( "navalmines", mine )
	
	return true
end
function TOOL:RightClick( trace )
	return self:LeftClick( trace, true )
end

// Get's client convars and checks the types are correct.
function TOOL:GetValues( types )
	local vals = {}
	for name, _ in pairs( self.ClientConVar ) do
		local v = self:GetClientInfo( name )
		if ( tonumber( v ) != nil ) then v = tonumber( v ) end
		if ( types[ name ] && types[ name ] != type( v ) ) then return false end
		vals[ name ] = v
	end
	return vals
end

function TOOL.BuildCPanel( panel )
	// Model selection.
	local model = vgui.Create( "PropSelect", panel )
		model:SetConVar( "rt_navalmines_model" )
		for m, p in pairs( list.Get( "NavalMineModels" ) ) do
			model:AddModel( m )
		end
	panel:AddItem( model )
	
	panel:NumSlider( "Rope Length", "rt_navalmines_ropelength", 10, 500 )
	panel:NumSlider( "Min. Speed", "rt_navalmines_speed", -1, 500 )
	panel:NumSlider( "Damage", "rt_navalmines_damage", 0, 500 )
	panel:NumSlider( "Radius", "rt_navalmines_radius", -1, 500 )
	panel:NumSlider( "Health", "rt_navalmines_health", -1, 500 )
	panel:CheckBox( "Only explode underwater", "rt_navalmines_onlywater" )
end

// Add the default models.
list.Set( "NavalMineModels", "models/combine_helicopter/helicopter_bomb01.mdl", Vector( 0, 0, -13 ) )
list.Set( "NavalMineModels", "models/magnet/submine/submine.mdl", Vector( 0, 0, -28.5 ) )
list.Set( "NavalMineModels", "models/roller_old_spikes.mdl", Vector( 0, 0, -11 ) )
list.Set( "NavalMineModels", "models/roller.mdl", Vector( 0, 0, -11 ) )
